// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.26.0
// source: list_peers.sql

package queries

import (
	"context"

	"github.com/jackc/pgx/v5/pgtype"
)

const listDirectoryPeers = `-- name: ListDirectoryPeers :many
SELECT
    p.id,
    p.name,
    p.manager_address,
    STRING_AGG(pr.role::text, ', ')::text AS roles
FROM peers.peers as p
    JOIN peers.peers_roles pr ON (p.id = pr.peer_id AND pr.role = 'ROLE_DIRECTORY')
WHERE
    p.name IS NOT NULL AND
    p.manager_address IS NOT NULL
GROUP BY p.id
`

type ListDirectoryPeersRow struct {
	ID             string
	Name           pgtype.Text
	ManagerAddress pgtype.Text
	Roles          string
}

func (q *Queries) ListDirectoryPeers(ctx context.Context) ([]*ListDirectoryPeersRow, error) {
	rows, err := q.db.Query(ctx, listDirectoryPeers)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListDirectoryPeersRow{}
	for rows.Next() {
		var i ListDirectoryPeersRow
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.ManagerAddress,
			&i.Roles,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const listPeers = `-- name: ListPeers :many

SELECT
    p.id,
    p.name,
    p.manager_address,
    -- coalesce is used to return an empty string if the value is null. the code generate by sqlc is unable to handle null values in this context.
    coalesce(STRING_AGG(pr.role::text, ', '),'')::text AS roles
FROM peers.peers as p
LEFT JOIN peers.peers_roles pr ON p.id = pr.peer_id
WHERE
    p.name IS NOT NULL AND
    p.manager_address IS NOT NULL AND
    (
             $2::text = ''
         OR
             ($3::text = 'asc' AND p.id > $2::text)
         OR
             ($3::text = 'desc' AND p.id < $2::text)
     )
GROUP BY p.id
ORDER BY
    CASE
        WHEN $3::text = 'asc' THEN p.id END ASC,
    CASE
        WHEN $3::text = 'desc' THEN p.id END DESC
LIMIT $1
`

type ListPeersParams struct {
	Limit             int32
	PaginationStartID string
	OrderDirection    string
}

type ListPeersRow struct {
	ID             string
	Name           pgtype.Text
	ManagerAddress pgtype.Text
	Roles          string
}

// Copyright © VNG Realisatie 2023
// Licensed under the EUPL
func (q *Queries) ListPeers(ctx context.Context, arg *ListPeersParams) ([]*ListPeersRow, error) {
	rows, err := q.db.Query(ctx, listPeers, arg.Limit, arg.PaginationStartID, arg.OrderDirection)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []*ListPeersRow{}
	for rows.Next() {
		var i ListPeersRow
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.ManagerAddress,
			&i.Roles,
		); err != nil {
			return nil, err
		}
		items = append(items, &i)
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
